close all
clear all

ds_fact = 0.25;
ipDir = ['table/' num2str(ds_fact) '/'];
ipGt = [ipDir 'gt/'];
ipClean = [ipDir 'clean/'];
ipScsr = [ipDir 'scsr/'];
ipMRF = [ipDir 'mrf/'];
ipUs = [ipDir 'us/'];  % our results ECCV 2012


filesGT = dir([ipGt '*.mat']);
filesClean = dir([ipClean '*.mat']);
filesUs = dir([ipUs '*.mat']);
filesScsr = dir([ipScsr '*.mat']);
filesMRF = dir([ipMRF '*.png']);

errType = 'rmse'; %perc1, rmse
nMethods = 4;
nScenes = 3;

results = ones(nMethods, nScenes)*Inf;

for i=1:nScenes;
    [filesGT(i).name  filesScsr(i).name filesMRF(i).name filesUs(i).name]
    
    load([ipGt filesGT(i).name]);
    gtIm = D;

    %% analyitic - computed without holes
    load([ipClean filesClean(i).name]);
    gtImClean = D;
    gtImNN = imresize(imresize(gtImClean,ds_fact,'nearest'),[size(gtImClean)],'nearest');
    
     %% scsr
    load([ipScsr filesScsr(i).name]);
    gtScsr = unScale(D,gtImClean);
    if (sum(size(gtScsr) == size(gtIm))~=2)
        %gtScsr(end,:) = [];
        gtScsr = imresize(gtScsr,size(gtIm), 'nearest');
    end
    
    %% freeman 
    gtMRF = double(imread([ipMRF filesMRF(i).name]));
    gtMRF = gtMRF(:,:,1);
    gtMRF = unScale(gtMRF,gtImClean);
    if (sum(size(gtMRF) == size(gtIm))~=2)
        %gtScsr(end,:) = [];
        gtMRF = imresize(gtMRF,size(gtIm), 'nearest');
    end
    
    %% our results
    load([ipUs filesUs(i).name]);
    gtUs = superRes;
    if (sum(size(gtUs) == size(gtIm))~=2)
        %gtUs(end,:) = [];
        gtUs = imresize(gtUs,size(gtIm), 'nearest');
    end    
    
    
    results(1,i) = calcError(gtImNN, gtIm, errType);
    %results(2,i) = calcError(gtImBI, gtIm, errType);
    %results(3,i) = calcError(gtImBC, gtIm, errType);
    results(2,i) = calcError(gtScsr, gtIm, errType);
    results(3,i) = calcError(gtMRF, gtIm, errType);
    results(4,i) = calcError(gtUs, gtIm, errType);
    
end


% table
fprintf('\n \n');
fprintf('scan021 & scan030 & scan042\n');
% write table for latex
[v ind] = min(results);
indM = zeros(size(results));
sub = sub2ind(size(results), ind ,[1:nScenes]);
indM(sub) = 1;
for j=1:nMethods
    for i = 1:nScenes
        if (indM(j,i) == 1)
            fprintf('&\\textbf{%6.3f} ', results(j,i));
        else
            fprintf('&%6.3f ', results(j,i));
        end
    end
    fprintf(' \\\\ \n');
end
